routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\KategoriController;
use App\Http\Controllers\Admin\ListprodukController;
use App\Http\Controllers\Admin\UkuranController;
use App\Http\Controllers\Admin\DetailprodukController;
use App\Http\Controllers\Admin\TransaksiController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\DetailtransaksiController;
use App\Http\Controllers\Admin\LogtransaksiController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('listproduk', ListprodukController::class);
Route::resource('kategori', KategoriController::class);  
Route::resource('ukuran', UkuranController::class);
Route::resource('detailproduk', DetailprodukController::class);
Route::get('/admin/detailproduk/{id_produk}/tambah', [DetailProdukController::class, 'createWithProduk']);
Route::post('/admin/detailproduk/{id_produk}', [DetailProdukController::class, 'store']);
Route::resource('transaksi', TransaksiController::class);
Route::resource('user', UserController::class);
Route::resource('detailtransaksi', DetailtransaksiController::class);
Route::resource('logtransaksi', LogtransaksiController::class);


// Route::get('/searchproduct', [TransaksiController::class, 'search_product']);
// Route::get('/search','TransaksiController@search');

Route::get('/cart', function () {
    $cart = session('cart');
dd($cart);
});
Route::get('/cart/tambah/{id}', [TransaksiController::class, 'tambah_cart'])->where('id', '[0-9]+');
Route::get('/cart/hapus/{id}', [TransaksiController::class, 'hapus_cart'])->where('id', '[0-9]+');
Route::post('/cart/ubah/quantity/{id}', [TransaksiController::class, 'edit_quantity']);




Route::get('/admin/dashboard', [DashboardController::class, 'index'])->name('dashboard');
//Route::get('/admin/kategori/index', [KategoriController::class, 'index'])->name('kategori');
//Route::get('admin/kategori/form', [DashboardController::class, 'create'])->name('kategori');
//Route::get('/admin/kategori/ukuran', [UkuranController::class, 'index'])->name('kategori');

//Route::get('/admin/kategori/listproduk', [ListprodukController::class, 'index'])->name('kategori');
//Route::get('/produk/create', [ListprodukController::class, 'create'] );
//Route::post('/produk', [ListprodukController::class, 'store'] );

//Route::get('admin/kategori/formkategori', [KategoriController::class, 'create'])->name('kategori');
//Route::get('admin/kategori/formukuran', [UkuranController::class, 'create'])->name('kategori');
//Route::get('admin/kategori/formlist', [ListprodukController::class, 'create'])->name('kategori');

app/Models/DetailProduk.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class DetailProduk extends Model
{
    use HasFactory;

    protected $table = 'detail_produk';

    protected $fillable = [
        'id_produk', 'id_ukuran', 'stok', 'hpp', 'harga'
    ]; 
    
    public function produk()
    {
        return $this->hasOne(Produk::class,'id', 'id_produk');
    }

    public function ukuran()
    {
        return $this->belongsTo(Ukuran::class, 'id_ukuran');
    }

    public function transaksi_detail()
    {
        return $this->hasMany(DetailTransaksi::class, 'id_detail_produk','id');
    }

}

app/Http/Controllers/Admin/DetailprodukController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\DetailProduk;
use Illuminate\Http\Request;
use App\Models\Ukuran;
use App\Models\Produk;

class DetailprodukController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $data['detailproduk'] = DetailProduk::all();
        return view('admin.detailproduk.index', $data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $listproduk ['listproduk'] = Produk::all();
        $data['ukuran'] = Ukuran::all();
        return view('admin.detailproduk.form', $listproduk, $data);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $rule = [
            'id_produk => required',
            'id_ukuran => required',
            'stok => required',
            'hpp => required',
            'harga => required'

        ];
        $customMessages = [
            'id_produk.required' => 'Field Id Produk Wajib Diisi!',
            'id_ukuran.required' => 'Field Id Ukuran Wajib Diisi',
            'stok' => 'Field Stok Wajib Diisi',
            'hpp.required' => 'Field HPP Wajib Diisi!',
            'harga.required' => 'Field Harga Wajib Diisi!',
        ];

        $this->validate($request, $rule, $customMessages);
        
        $input = $request->all();

        $status = DetailProduk::create($input);
        if ($status){
            return redirect('/listproduk/'.$request->id_produk.'/edit')->with('success', 'Data berhasil diubah');
        }else{
            return redirect('/listproduk/'.$request->id_produk.'/edit')->with('error', 'Data gagal diubah');
        }
    

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $detailproduk = DetailProduk::find($id);
        $data['listproduk'] = Produk::all();
        $data ['ukuran'] = Ukuran::all();
        $data['detailproduk'] = $detailproduk;
        return view('admin.detailproduk.form', $data);
    
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $rule = [
            'id_produk => required',
            'id_ukuran => required',
            'stok => required',
            'hpp => required',
            'harga => required'

        ];
        $customMessages = [
            'id_produk.required' => 'Field Id Produk Wajib Diisi!',
            'id_ukuran.required' => 'Field Id Ukuran Wajib Diisi',
            'stok' => 'Field Stok Wajib Diisi',
            'hpp.required' => 'Field HPP Wajib Diisi!',
            'harga.required' => 'Field Harga Wajib Diisi!',
        ];

        $this->validate($request, $rule, $customMessages);
        $input = $request->all();

        $detailproduk = DetailProduk::find($id);
        $detailproduk->id_produk= $request->id_produk;
        $detailproduk->id_ukuran = $request->id_ukuran;
        $detailproduk->stok = $request->stok;
        $detailproduk->hpp = $request->hpp;
        $detailproduk->harga = $request->harga;


        $status = $detailproduk->save();
        if ($status){
            return redirect('/listproduk/'.$request->id_produk.'/edit')->with('success', 'Data berhasil diubah');
        }else{
            return redirect('/listproduk/'.$request->id_produk.'/edit')->with('error', 'Data gagal diubah');
        }
    
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $detailproduk = DetailProduk::find($id);
        $status = $detailproduk->delete();
        
        if ($status) {
            return 1;
        }else{
            return 0;
        
        }
    }

    public function createWithProduk($id){
        $data['id_produk'] = $id;
        $data['ukuran'] = Ukuran::all();
        return view ('admin.detailproduk.form', $data);
    }
    public function storeWithProduk(Request $request, $id){
        $rule = [
            'id_produk' => 'required',
            'id_ukuran' => 'required',
            'stok' => 'required',
            'hpp' => 'required',
            'harga' => 'required'
        ];
        $customMessages = [
            'id_produk.required' => 'Field Id Produk Wajib Diisi!',
                'id_ukuran.required' => 'Field Id Ukuran Wajib Diisi',
                'stok' => 'Field Stok Wajib Diisi',
                'hpp.required' => 'Field HPP Wajib Diisi!',
                'harga.required' => 'Field Harga Wajib Diisi!',
            ];
        $this->validate($request, $rule, $customMessages);
        // $id_Produk = '11';
        // $request['id_produk'] = $id_Produk;
        $input = $request->all();
       
        $status = DetailProduk::create($input);
        if ($status){
            return redirect('detailproduk')->with('success', 'Data berhasil ditambahkan');
        }else{
            return redirect('detailproduk/create')->with('error', 'Data gagal Ditambahkan');
        }
    }
    
        
    
}

resources/views/admin/detailproduk/form.blade.php
@extends('admin.layout.app')

@section('content')
    <!-- BEGIN: Content-->
    <div class="app-content content ">
        <div class="content-overlay"></div>
        <div class="header-navbar-shadow"></div>
        <div class="content-wrapper">
            <div class="content-header row">
                <div class="content-header-left col-md-9 col-12 mb-2">
                    <div class="row breadcrumbs-top">
                        <div class="col-12">
                            <h2 class="content-header-title float-left mb-0">Form Layouts</h2>
                            <div class="breadcrumb-wrapper">
                                <ol class="breadcrumb">
                                    <li class="breadcrumb-item"><a href="{{url('/admin/detailproduk/index')}}">Home</a>
                                    </li>
                                    <li class="breadcrumb-item"><a href="#">Forms</a>
                                    </li>
                                    <li class="breadcrumb-item active"><a href="#">Form Layouts</a>
                                    </li>
                                </ol>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="content-header-right text-md-right col-md-3 col-12 d-md-block d-none">
                    <div class="form-group breadcrumb-right">
                        <div class="dropdown">
                            <button class="btn-icon btn btn-primary btn-round btn-sm dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i data-feather="grid"></i></button>
                            <div class="dropdown-menu dropdown-menu-right"><a class="dropdown-item" href="app-todo.html"><i class="mr-1" data-feather="check-square"></i><span class="align-middle">Todo</span></a><a class="dropdown-item" href="app-chat.html"><i class="mr-1" data-feather="message-square"></i><span class="align-middle">Chat</span></a><a class="dropdown-item" href="app-email.html"><i class="mr-1" data-feather="mail"></i><span class="align-middle">Email</span></a><a class="dropdown-item" href="app-calendar.html"><i class="mr-1" data-feather="calendar"></i><span class="align-middle">Calendar</span></a></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="content-body">
                <!-- Basic Horizontal form layout section start -->
                <section id="basic-horizontal-layouts">
                    <div class="row justify-content-center">
                        <div class="col-md-12 col-12">
                            <div class="card">
                                <div class="card-header">
                                    <h4 class="card-title">Detail Produk</h4>
                                </div>
                                <div class="card-body">
                                    @if ($errors->any())
                                    <div class="alert alert-danger" role="alert">
                                    <h4 class="alert-heading">Error!</h4>
                                    @foreach ($errors->all() as $error)
                                        <div class="alert-body">
                                            {{$error}}
                                        </div>
                                    @endforeach
                                    </div>
                                    @endif
                                    <form class="form form-horizontal" method="POST" action="{{@$detailproduk ? route('detailproduk.update',@$detailproduk->id) : url('admin/detailproduk/{id_produk}'. @$detailProduk->id)}}" enctype="multipart/form-data">
                                        @csrf
                                        @if (@$detailproduk)
                                        @method('patch')
                                        @endif
                                        <div class="row">
                                        
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label"></div>
                                                    <div class="col-sm-9">
                                                        <input type="hidden" name="id_produk" class="form-control" value="{{@$detailproduk ? $detailproduk->id_produk : $id_produk }}">
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label">
                                                        <label for="id_kategori">Ukuran</label>
                                                    </div>
                                                    <div class="col-9">
                                                        <select class="form-control select2" id="id_ukuran" name="id_ukuran">
                                                            <option value="">-- PILIH UKURAN --</option>
                                                            @foreach ($ukuran as $row)
                                                            <option value="{{$row->id}}" {{@$detailproduk->id_ukuran == $row->id ? "selected" : ''}}>
                                                            {{$row->ukuran}}
                                                            </option>
                                                            @endforeach
                                                        </select>
                                                    </div>
                                                        <div class="col-sm-9 offset-sm-3">
                                                            <a href="{{route ('ukuran.create')}}" class="btn btn-outline-secondary">Tambah Ukuran</a>
                                                        </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label">
                                                        <label for="email-id">Stok</label>
                                                    </div>
                                                    <div class="col-sm-9">
                                                        <input type="text" id="stok" class="form-control" name="stok" placeholder="stok" value="{{old('stok', @$detailproduk ? $detailproduk->stok: '')}}"/>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label">
                                                        <label for="email-id">HPP</label>
                                                    </div>
                                                    <div class="col-sm-9">
                                                        <input type="text" id="hpp" class="form-control" name="hpp" placeholder="hpp" value="{{old('hpp', @$detailproduk ? $detailproduk->hpp: '')}}"/>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label">
                                                        <label for="email-id">Harga</label>
                                                    </div>
                                                    <div class="col-sm-9">
                                                        <input type="text" id="harga" class="form-control" name="harga" placeholder="harga" value="{{old('harga', @$detailproduk ? $detailproduk->harga: '')}}"/>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="col-sm-9 offset-sm-3">
                                                <button type="submit" class="btn btn-primary mr-1">Submit</button>
                                                <button type="reset" class="btn btn-outline-secondary">Reset</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                </section>
                <!-- Basic Horizontal form layout section end -->
            </div>
        </div>
    </div>
    <!-- END: Content-->
@endsection

resources/views/admin/detailproduk/index.blade.php
@extends('admin.layout.app')
@section('content')
    <!-- BEGIN: Content-->
    <div class="app-content content ">
        <div class="content-overlay"></div>
        <div class="header-navbar-shadow"></div>
        <div class="content-wrapper">
            <div class="content-header row">
                <div class="content-header-left col-md-9 col-12 mb-2">
                    <div class="row breadcrumbs-top">
                        <div class="col-12">
                            <h2 class="content-header-title float-left mb-0">Bootstrap Tables</h2>
                            <div class="breadcrumb-wrapper">
                                <ol class="breadcrumb">
                                    <li class="breadcrumb-item"><a href="index.html">Home</a>
                                    </li>
                                    <li class="breadcrumb-item active">Table Bootstrap
                                    </li>
                                </ol>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="content-header-right text-md-right col-md-3 col-12 d-md-block d-none">
                    <div class="form-group breadcrumb-right">
                        <div class="dropdown">
                            <button class="btn-icon btn btn-primary btn-round btn-sm dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i data-feather="grid"></i></button>
                            <div class="dropdown-menu dropdown-menu-right"><a class="dropdown-item" href="app-todo.html"><i class="mr-1" data-feather="check-square"></i><span class="align-middle">Todo</span></a><a class="dropdown-item" href="app-chat.html"><i class="mr-1" data-feather="message-square"></i><span class="align-middle">Chat</span></a><a class="dropdown-item" href="app-email.html"><i class="mr-1" data-feather="mail"></i><span class="align-middle">Email</span></a><a class="dropdown-item" href="app-calendar.html"><i class="mr-1" data-feather="calendar"></i><span class="align-middle">Calendar</span></a></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="content-body">
                <!-- Bordered table start -->
                <div class="row" id="table-bordered">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-header">
                                <h4 class="card-title">Tabel Detail Produk</h4>
                                <a href="{{route('detailproduk.create')}}" class="btn btn-primary">Tambah Data</a>
                            </div>
                            <div class="card-body">
                                <p class="card-text">
                                </p>
                            </div>
                            <div class="table-responsive">
                                <table class="table table-bordered">
                                    <thead>
                                        <tr>
                                            <th>No</th>
                                            {{-- <th>Nama Produk</th> --}}
                                            <th>Ukuran</th>
                                            <th>Stok</th>
                                            <th>HPP</th>
                                            <th>Harga</th>
                                            <th>Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($detailproduk as $row)
                                        <td>{{$loop->iteration}}</td>
                                        {{-- <td>{{$row->produk->nama_produk}}</td> --}}
                                        <td>{{$row->ukuran->ukuran}}</td> 
                                        <td>{{$row->stok}}</td>
                                        <td>{{$row->hpp}}</td>
                                        <td>{{$row->harga}}</td>

                                        <td>
                                            <a href="{{route('detailproduk.edit', $row->id)}}" class="btn btn-warning">Edit </a>
                                            <a href="#" data-id="{{$row->id}}" class="btn btn-danger btn-del">Delete</a>
                                        </td>
                                    </tbody>
                                    @endforeach
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Bordered table end -->

            </div>
        </div>
    </div>
    <!-- END: Content-->
@endsection

@push('scripts')
<script>
    $(document).on('click', '.btn-del', function () {
        var id = $(this).data('id');
        Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    $.ajax({
                        'url': '{{url('detailproduk')}}/' + id,
                        'type': 'post',
                        'data': {
                            '_method': 'DELETE',
                            '_token': '{{csrf_token()}}'
                        },
                        success: function (response) {
                            if (response == 1) {
                                Swal.fire(
                                    'Deleted!',
                                    'Your file has been deleted.',
                                    'success'
                                )
                                window.setTimeout(function () {
                                    location.reload();
                                }, 2000);
                            } else {
                                Swal.fire({
                                    icon: 'error',
                                    title: 'Oops...',
                                    text: 'Data gagal dihapus!'
                                });
                            }
                        }
                    });
                }
            });
        });
    </script>
@endpush